/*----- PROTECTED REGION ID(Agilent33x20A.h) ENABLED START -----*/
//=============================================================================
//
// file :        Agilent33x20A.h
//
// description : Include file for the Agilent33x20A class
//
// project :     Agilent 33x20a signal generator
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
// $Author:  $
//
// $Revision:  $
// $Date:  $
//
// $HeadURL:  $
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef Agilent33x20A_H
#define Agilent33x20A_H

#include <tango.h>


/*----- PROTECTED REGION END -----*/	//	Agilent33x20A.h

/**
 *  Agilent33x20A class description:
 *    This class implements the standard signal generator interface for the Agilent 33120a
 *    and 33220a signal generators.
 */

namespace Agilent33x20A_ns
{
/*----- PROTECTED REGION ID(Agilent33x20A::Additional Class Declarations) ENABLED START -----*/

//	Additional Class Declarations

/*----- PROTECTED REGION END -----*/	//	Agilent33x20A::Additional Class Declarations

class Agilent33x20A : public Tango::Device_4Impl
{

/*----- PROTECTED REGION ID(Agilent33x20A::Data Members) ENABLED START -----*/

//	Add your own data members
public:



/*----- PROTECTED REGION END -----*/	//	Agilent33x20A::Data Members

//	Device property data members
public:
	//	GpibServer:	name of gpib device proxy e.g. sr/d-tm/hp33120-gpib
	string	gpibServer;
	//	WaveformFile:	Filename where the waveform is saved
	string	waveformFile;

//	Attribute data members
public:
  Tango::DevDouble  attr_Frequency_read;
  Tango::DevDouble  attr_Frequency_write;
  Tango::DevDouble  attr_Voltage_read;
  Tango::DevDouble  attr_Voltage_write;
  Tango::DevDouble  attr_VoltageOffset_read;
  Tango::DevDouble  attr_VoltageOffset_write;
  Tango::DevString	attr_Function_read;
	Tango::DevDouble	attr_SweepStartFrequency_read;
	Tango::DevDouble	attr_SweepStopFrequency_read;
  Tango::DevString  attr_SweepSpacing_read;
  Tango::DevString  attr_SweepSpacing_write;
  Tango::DevDouble  attr_SweepTime_read;
  Tango::DevDouble  attr_SweepTime_write;
  Tango::DevString  attr_TriggerSource_read;
  Tango::DevString  attr_TriggerSource_write;
  Tango::DevLong	  attr_BurstCycles_read;
	Tango::DevDouble	attr_BurstPhase_read;
	Tango::DevDouble	attr_BurstRate_read;
	Tango::DevString	attr_Mode_read;
	Tango::DevDouble	*attr_Waveform_read;
	Tango::DevString	attr_ModulationSource_read;
	Tango::DevDouble	attr_ModulationFrequency_read;
	Tango::DevString	attr_ModulationFunction_read;
	Tango::DevDouble	attr_AMDepth_read;
	Tango::DevDouble	attr_FMDeviation_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Agilent33x20A(Tango::DeviceClass *cl,string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	Agilent33x20A(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	Agilent33x20A(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */	
	~Agilent33x20A() {delete_device();};


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();


//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method      : Agilent33x20A::read_attr_hardware()
	 *	Description : Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(vector<long> &attr_list);
	//--------------------------------------------------------
	/*
	 *	Method      : Agilent33x20A::write_attr_hardware()
	 *	Description : Hardware writing for attributes.
	 */
	//--------------------------------------------------------
	virtual void write_attr_hardware(vector<long> &attr_list);

/**
 *	Attribute Frequency related methods
 *	Description: frequency
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Frequency(Tango::Attribute &attr);
	virtual void write_Frequency(Tango::WAttribute &attr);
	virtual bool is_Frequency_allowed(Tango::AttReqType type);
/**
 *	Attribute Voltage related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_Voltage(Tango::Attribute &attr);
	virtual void write_Voltage(Tango::WAttribute &attr);
	virtual bool is_Voltage_allowed(Tango::AttReqType type);
/**
 *	Attribute VoltageOffset related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_VoltageOffset(Tango::Attribute &attr);
	virtual void write_VoltageOffset(Tango::WAttribute &attr);
	virtual bool is_VoltageOffset_allowed(Tango::AttReqType type);
/**
 *	Attribute Function related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Function(Tango::Attribute &attr);
	virtual void write_Function(Tango::WAttribute &attr);
	virtual bool is_Function_allowed(Tango::AttReqType type);
/**
 *	Attribute SweepStartFrequency related methods
 *	Description: start sweep frequency
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_SweepStartFrequency(Tango::Attribute &attr);
	virtual void write_SweepStartFrequency(Tango::WAttribute &attr);
	virtual bool is_SweepStartFrequency_allowed(Tango::AttReqType type);
/**
 *	Attribute SweepStopFrequency related methods
 *	Description: stop sweep frequency
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_SweepStopFrequency(Tango::Attribute &attr);
	virtual void write_SweepStopFrequency(Tango::WAttribute &attr);
	virtual bool is_SweepStopFrequency_allowed(Tango::AttReqType type);
/**
 *	Attribute SweepSpacing related methods
 *	Description: Allowed values :
 *               LIN for linear
 *               LOG for logarithmic
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_SweepSpacing(Tango::Attribute &attr);
	virtual void write_SweepSpacing(Tango::WAttribute &attr);
	virtual bool is_SweepSpacing_allowed(Tango::AttReqType type);
/**
 *	Attribute SweepTime related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_SweepTime(Tango::Attribute &attr);
	virtual void write_SweepTime(Tango::WAttribute &attr);
	virtual bool is_SweepTime_allowed(Tango::AttReqType type);
/**
 *	Attribute TriggerSource related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_TriggerSource(Tango::Attribute &attr);
	virtual void write_TriggerSource(Tango::WAttribute &attr);
	virtual bool is_TriggerSource_allowed(Tango::AttReqType type);
/**
 *	Attribute BurstCycles related methods
 *	Description: number of burst cycles when in burst mode
 *
 *	Data type:	Tango::DevLong
 *	Attr type:	Scalar
 */
	virtual void read_BurstCycles(Tango::Attribute &attr);
	virtual void write_BurstCycles(Tango::WAttribute &attr);
	virtual bool is_BurstCycles_allowed(Tango::AttReqType type);
/**
 *	Attribute BurstPhase related methods
 *	Description: the start phase of the signal generated when in burst mode
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_BurstPhase(Tango::Attribute &attr);
	virtual void write_BurstPhase(Tango::WAttribute &attr);
	virtual bool is_BurstPhase_allowed(Tango::AttReqType type);
/**
 *	Attribute BurstRate related methods
 *	Description: rate at which bursts will be generated when in burst mode
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_BurstRate(Tango::Attribute &attr);
	virtual void write_BurstRate(Tango::WAttribute &attr);
	virtual bool is_BurstRate_allowed(Tango::AttReqType type);
/**
 *	Attribute Mode related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_Mode(Tango::Attribute &attr);
	virtual void write_Mode(Tango::WAttribute &attr);
	virtual bool is_Mode_allowed(Tango::AttReqType type);
/**
 *	Attribute ModulationSource related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_ModulationSource(Tango::Attribute &attr);
	virtual void write_ModulationSource(Tango::WAttribute &attr);
	virtual bool is_ModulationSource_allowed(Tango::AttReqType type);
/**
 *	Attribute ModulationFrequency related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_ModulationFrequency(Tango::Attribute &attr);
	virtual void write_ModulationFrequency(Tango::WAttribute &attr);
	virtual bool is_ModulationFrequency_allowed(Tango::AttReqType type);
/**
 *	Attribute ModulationFunction related methods
 *	Description: 
 *
 *	Data type:	Tango::DevString
 *	Attr type:	Scalar
 */
	virtual void read_ModulationFunction(Tango::Attribute &attr);
	virtual void write_ModulationFunction(Tango::WAttribute &attr);
	virtual bool is_ModulationFunction_allowed(Tango::AttReqType type);
/**
 *	Attribute AMDepth related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_AMDepth(Tango::Attribute &attr);
	virtual void write_AMDepth(Tango::WAttribute &attr);
	virtual bool is_AMDepth_allowed(Tango::AttReqType type);
/**
 *	Attribute FMDeviation related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_FMDeviation(Tango::Attribute &attr);
	virtual void write_FMDeviation(Tango::WAttribute &attr);
	virtual bool is_FMDeviation_allowed(Tango::AttReqType type);
/**
 *	Attribute Waveform related methods
 *	Description: 
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Spectrum max = 16384
 */
	virtual void read_Waveform(Tango::Attribute &attr);
	virtual void write_Waveform(Tango::WAttribute &attr);
	virtual bool is_Waveform_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method      : Agilent33x20A::add_dynamic_attributes()
	 *	Description : Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();



//	Command related methods
public:
	/**
	 *	Command Status related method
	 *	Description: This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.
	 *
	 *	@returns Status description
	 */
	virtual Tango::ConstDevString dev_status();
	/**
	 *	Command On related method
	 *	Description: Switch signal generation ON according to settings.
	 *
	 */
	virtual void on();
	virtual bool is_On_allowed(const CORBA::Any &any);
	/**
	 *	Command Off related method
	 *	Description: Switch signal generation OFF.
	 *
	 */
	virtual void off();
	virtual bool is_Off_allowed(const CORBA::Any &any);
	/**
	 *	Command Reset related method
	 *	Description: 
	 *
	 */
	virtual void reset();
	virtual bool is_Reset_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method      : Agilent33x20A::add_dynamic_commands()
	 *	Description : Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(Agilent33x20A::Additional Method prototypes) ENABLED START -----*/

//	Additional Method prototypes
protected :	
        string mode;
		/*
			NOTE : This booleen is used to identify the Agilent model used.
			If it is not a 33120 it can support "OUTPut ON/OFF" commands : is_cmd_supported = TRUE !!!
			For the 33120, Andy Gotz (from the ESRF) have found a special trick
				for this model to emulate the "OUTPut ON/OFF" commands.
		*/
		bool is_cmd_supported;

        virtual Tango::DevString get_function();
        virtual void set_function(Tango::DevString argin);
        virtual Tango::DevDouble get_frequency();
        virtual void set_frequency(Tango::DevDouble argin);
        virtual Tango::DevDouble get_start_sweep_frequency();
        virtual void set_start_sweep_frequency(Tango::DevDouble argin);
        virtual Tango::DevDouble get_stop_sweep_frequency();
        virtual void set_stop_sweep_frequency(Tango::DevDouble argin);
        virtual Tango::DevString get_sweep_spacing();
        virtual void set_sweep_spacing(Tango::DevString argin);
        virtual Tango::DevDouble get_sweep_time();
        virtual void set_sweep_time(Tango::DevDouble argin);
        virtual Tango::DevDouble get_voltage();
        virtual void set_voltage(Tango::DevDouble argin);
        virtual Tango::DevDouble get_voltage_offset();
        virtual void set_voltage_offset(Tango::DevDouble argin);
        virtual Tango::DevBoolean get_sweep_state();
        virtual void set_sweep_state(Tango::DevString argin);
        void define_user_waveform(vector<double> &argin);
        virtual void function_gaussian();
        virtual Tango::DevString get_trigger_source();
        virtual void set_trigger_source(Tango::DevString argin);
        virtual Tango::DevLong get_burst_cycles();
        virtual void set_burst_cycles(Tango::DevLong argin);
        virtual Tango::DevDouble get_burst_rate();
        virtual void set_burst_rate(Tango::DevDouble argin);
        virtual Tango::DevDouble get_burst_phase();
        virtual void set_burst_phase(Tango::DevDouble argin);
        virtual Tango::DevString get_mode();
        virtual void set_mode(Tango::DevString argin);
        virtual Tango::DevString get_modulationSource();
        virtual void set_modulationSource(Tango::DevString argin);
        virtual Tango::DevDouble get_ModulationFrequency();
        virtual void set_ModulationFrequency(Tango::DevDouble argin);
        virtual Tango::DevString get_ModulationFunction();
        virtual void set_ModulationFunction(Tango::DevString argin);
        virtual Tango::DevDouble get_AMDepth();
        virtual void set_AMDepth(Tango::DevDouble argin);
        virtual Tango::DevDouble get_FMDeviation();
        virtual void set_FMDeviation(Tango::DevDouble argin);
	void reload_waveform();

        virtual void am_on();
        virtual void fm_on();
        virtual void am_off();
        virtual void fm_off();
        virtual void frequency_on();
        virtual void sweep_on();
        virtual void burst_on();
        virtual void frequency_off();
        virtual void sweep_off();
        virtual void burst_off();


        Tango::DeviceProxy* DsProxyGpib;
	int waveFormLgth;

        std::string gpib_write_read(std::string argin);

#ifndef WIN32
        void signal_handler(long signo);
#endif

private :
	Tango::DevString _modulationSource;
	Tango::DevString _modulationFunction;
	Tango::DevString _sweepSpacing;
	Tango::DevString _triggerSrc;

/*----- PROTECTED REGION END -----*/	//	Agilent33x20A::Additional Method prototypes
};

/*----- PROTECTED REGION ID(Agilent33x20A::Additional Classes Definitions) ENABLED START -----*/

//	Additional Classes Definitions
int cmp_nocase(const std::string &s1, const std::string &s2);

/*----- PROTECTED REGION END -----*/	//	Agilent33x20A::Additional Classes Definitions

}	//	End of namespace

#endif   //	Agilent33x20A_H
